//	Interface Elements

if(!isObject(AvatarPhotoGUI))
{
	exec("./AvatarPhotoGUI.gui");
}
if(!isObject(AvatarPhotoSettings))
{
	exec("./AvatarPhotoSettings.gui");
}
if(!isObject(AvatarPhoto_ScreenshotButton))
{
	new GuiBitmapButtonCtrl(AvatarPhoto_ScreenshotButton)
	{
		profile = "BlockButtonProfile";
		position = "368 432";
		extent = "91 37";
		command = "AvatarPhoto();";
		text = "+ Screenshot";
		bitmap = "base/client/ui/button2";
		mColor = "125 255 125 255";
	};
	Avatar_Window.add(AvatarPhoto_ScreenshotButton);
}

//	Default Preferences

if($Pref::AvatarPhoto::HideMouse $= "")
{
	$Pref::AvatarPhoto::HideMouse = true;
}
if($Pref::AvatarPhoto::HeadHeight $= "")
{
	$Pref::AvatarPhoto::HeadHeight = true;
}
if($Pref::AvatarPhoto::CamDistance $= "")
{
	$Pref::AvatarPhoto::CamDistance = 8;
}

//	Interface Functions

function AvatarPhotoAnimationUpdate(%load)
{
	if(%load)
	{
		if(!AvatarPhotoAnimationsDrop.initialized)
		{
			AvatarPhotoAnimationsDrop.add("None", 0);
			AvatarPhotoAnimationsDrop.add("Activate", 1);
			AvatarPhotoAnimationsDrop.add("Flail", 2);
			AvatarPhotoAnimationsDrop.add("Sit", 3);
			AvatarPhotoAnimationsDrop.add("Crouch", 4);
			AvatarPhotoAnimationsDrop.add("Run", 5);
			AvatarPhotoAnimationsDrop.initialized = true;
		}
		AvatarPhotoAnimationsDrop.setSelected($Pref::AvatarPhoto::AnimationNumber);
		return true;
	}
	else
	{
		AvatarPhotoAnimationsDrop.setValue(AvatarPhotoAnimationsDrop.getTextByID(AvatarPhotoAnimationsDrop.getSelected()));
	}
	
	$Pref::AvatarPhoto::AnimationNumber = AvatarPhotoAnimationsDrop.getSelected();
}

function AvatarPhotoColourUpdate()
{
	AvatarPhotoColourPreview.setColor(mFloor($Pref::AvatarPhoto::BG::R) SPC mFloor($Pref::AvatarPhoto::BG::G) SPC mFloor($Pref::AvatarPhoto::BG::B) SPC "255");
	AvatarPhotoSliderR.setValue(mFloor($Pref::AvatarPhoto::BG::R));
	AvatarPhotoSliderG.setValue(mFloor($Pref::AvatarPhoto::BG::G));
	AvatarPhotoSliderB.setValue(mFloor($Pref::AvatarPhoto::BG::B));
}

function AvatarPhotoDistanceUpdate()
{
	if(mFloor($Pref::AvatarPhoto::CamDistance) > 50)
	{
		$Pref::AvatarPhoto::CamDistance = 50;
	}
	AvatarPhotoDistanceBox.setValue(mFloor($Pref::AvatarPhoto::CamDistance));
}

function AvatarPhotoColourDefault()
{
	AvatarPhotoSliderR.setValue(175);
	AvatarPhotoSliderG.setValue(198);
	AvatarPhotoSliderB.setValue(219);
	AvatarPhotoColourUpdate();
}

//	Most Important Function

function AvatarPhoto(%ready)
{
	if(!%ready)
	{
		AvatarPhotoAnimationUpdate(1);
		AvatarPhotoColourUpdate();
		AvatarPhotoDistanceUpdate();
		canvas.pushDialog(AvatarPhotoSettings);
		
		return true;
	}
	
	AvatarPhotoBackdrop.setColor(mFloor($Pref::AvatarPhoto::BG::R) SPC mFloor($Pref::AvatarPhoto::BG::G) SPC mFloor($Pref::AvatarPhoto::BG::B) SPC "255");
	AvatarPhotoBorder.setVisible($Pref::AvatarPhoto::Border);
	AvatarPhotoGradient.setVisible($Pref::AvatarPhoto::Gradient);
	canvas.pushDialog(AvatarPhotoGUI);
	%oldRes = getRes();
	setRes(640, 480, 32);
	deactivateDirectInput();
	canvas.popDialog(ConsoleDlg);
	cursorOff();
	
	AvatarPhoto.setObject("","base/data/shapes/player/m.dts","",100);
	
	if($hat0 $= "")
	{
		AvatarGui.onWake();
		deleteDatablocks();
	}
		
	AvatarPhoto.forceFOV = 18;
	AvatarPhoto.setOrbitDist($Pref::AvatarPhoto::CamDistance);
	AvatarPhoto.setCameraRot(0.22,0.5,2.8);
	AvatarPhoto.lightDirection = "0 0.2 0.2";
		
	%face = $Pref::Avatar::FaceName;
	%skincolor = $Pref::Avatar::HeadColor;
	%hat = $Pref::Avatar::Hat;
	%hatColor = $Pref::Avatar::HatColor;
	%accent = $Pref::Avatar::Accent;
	%accentColor = $Pref::Avatar::AccentColor;
	%chestDecal = $Pref::Avatar::DecalName;
	%pack = $pref::Avatar::Pack;
	%packColor = $pref::Avatar::PackColor;
	%secondPack = $Pref::Avatar::SecondPack;
	%secondPackColor = $pref::Avatar::SecondPackColor;
	
	%i=0;
	while($face[%i] !$= "")
	{
		if($face[%i] $= %face)
		{
			%face = %i;
			%foundFace = true;
			break;
		}
		%i++;
		
		if(%i > 500)
			break;
	}
	
	if(!%foundFace)
	{
		%i=0;
		while($face[%i] !$= "")
		{
			if(strStr(strLwr($face[%i]),"/" @ strLwr(%face) @ ".png") > -1)
			{
				%face = %i;
				break;
			}
			%i++;
			
			if(%i > 500)
				break;
		}
	}
	
	%i=0;
	while($decal[%i] !$= "")
	{
		if($decal[%i] $= %chestDecal)
		{
			%chestDecal = %i;
			%foundDecal = true;
			break;
		}
		%i++;
		
		if(%i > 500)
			break;
	}
	
	if(!%foundDecal)
	{
		%i=0;
		while($decal[%i] !$= "")
		{
			if(strStr(strLwr($decal[%i]),"/" @ strLwr(%chestDecal) @ ".png") > -1)
			{
				%chestDecal = %i;
				break;
			}
			%i++;
			
			if(%i > 500)
				break;
		}
	}

	%parts = "accent hat chest pack secondpack larm rarm lhand rhand hip lleg rleg";
	for(%i=0;%i<getWordCount(%parts);%i++)
	{
		%k = 0;
		eval("%partName = $"@getWord(%parts,%i)@%k@";");
		while(%partName !$= "")
		{
			if(%partName !$= "none")
				AvatarPhoto.hidenode("",%partName);
			eval("%partName = $"@getWord(%parts,%i)@%k++@";");
			%b++;
		}
	}
	
	AvatarPhoto.setNodeColor("","ALL",%skinColor);
	AvatarPhoto.setIFLFrame("","face",%face);
	AvatarPhoto.setIFLFrame("","decal",%chestDecal);
	
	if(%hat !$= "" && %hat !$= 0)
	{
		AvatarPhoto.unhidenode("",$hat[%hat]);
		AvatarPhoto.setnodeColor("",$hat[%hat],%hatColor);
		
		%accent = getWord($accentsAllowed[$hat[%hat]],%accent);
		if(%accent !$= "" && %accent !$= "none")
		{
			AvatarPhoto.unhidenode("",%accent);
			AvatarPhoto.setnodeColor("",%accent,%accentColor);
		}
	}
	
	if(%pack !$= "" && %pack !$= 0)
	{
		AvatarPhoto.unhidenode("",$pack[%pack]);
		AvatarPhoto.setnodeColor("",$pack[%pack],%packColor);
	}
	if(%secondpack !$= "" && %secondpack !$= 0)
	{
		AvatarPhoto.unhidenode("",$secondpack[%secondpack]);
		AvatarPhoto.setnodeColor("",$secondpack[%secondpack],%secondpackColor);
	}
	AvatarPhoto.unhidenode("",$chest[$Pref::Avatar::Chest]);
	AvatarPhoto.setNodeColor("",$chest[$Pref::Avatar::Chest],$pref::Avatar::TorsoColor);
	
	AvatarPhoto.unhidenode("",$hip[$Pref::Avatar::Hip]);
	AvatarPhoto.setNodeColor("",$hip[$Pref::Avatar::Hip],$pref::Avatar::HipColor);
	
	//go away skiis you're adopted
	if($Pref::AvatarPhoto::Skiis)
	{
		AvatarPhoto.setNodeColor("",RSki,51/255 SPC 0 SPC 204/255 SPC 255);
		AvatarPhoto.setNodeColor("",LSki,51/255 SPC 0 SPC 204/255 SPC 255);
	}
	else
	{
		AvatarPhoto.hidenode("",RSki);
		AvatarPhoto.hidenode("",LSki);
	}
	
	if($Pref::Avatar::Hip == 1)
	{
		AvatarPhoto.unhidenode("",SkirtTrimRight);
		AvatarPhoto.setNodeColor("",SkirtTrimRight,$pref::Avatar::RLegColor);
		AvatarPhoto.unhidenode("",SkirtTrimLeft);
		AvatarPhoto.setNodeColor("",SkirtTrimLeft,$pref::Avatar::LLegColor);
	}
	else
	{
		//go away skirt trims you are hopeless
		AvatarPhoto.hidenode("",SkirtTrimRight);
		AvatarPhoto.hidenode("",SkirtTrimLeft);
		
		AvatarPhoto.unhidenode("",$lleg[$Pref::Avatar::LLeg]);
		AvatarPhoto.setNodeColor("",$lleg[$Pref::Avatar::LLeg],$pref::Avatar::LLegColor);
		AvatarPhoto.unhidenode("",$rleg[$Pref::Avatar::RLeg]);
		AvatarPhoto.setNodeColor("",$rleg[$Pref::Avatar::RLeg],$pref::Avatar::RLegColor);
	}
	
	AvatarPhoto.unhidenode("",$larm[$Pref::Avatar::LArm]);
	AvatarPhoto.setNodeColor("",$larm[$Pref::Avatar::LArm],$pref::Avatar::LArmColor);
	AvatarPhoto.unhidenode("",$rarm[$Pref::Avatar::RArm]);
	AvatarPhoto.setNodeColor("",$rarm[$Pref::Avatar::RArm],$pref::Avatar::RArmColor);
	
	AvatarPhoto.unhidenode("",$lhand[$Pref::Avatar::LHand]);
	AvatarPhoto.setNodeColor("",$lhand[$Pref::Avatar::LHand],$pref::Avatar::LHandColor);
	AvatarPhoto.unhidenode("",$rhand[$Pref::Avatar::RHand]);
	AvatarPhoto.setNodeColor("",$rhand[$Pref::Avatar::RHand],$pref::Avatar::RHandColor);
	
	AvatarPhoto.setMouse(0,0);
	
	AvatarPhoto.setSequence("", 1, root, 0);
	if($Pref::AvatarPhoto::HeadHeight && ((%pack !$= "" && %pack != 0) || (%secondpack !$= "" && %secondpack != 0)))
	{
		//raise head
		AvatarPhoto.setSequence("", 1, headup, 1);
	}
	
	//		ANIMATIONS
	
	switch($Pref::AvatarPhoto::AnimationNumber)
	{
		case 0:
			AvatarPhoto.setSequence("", 0, root, 0);
		case 1:
			AvatarPhoto.setSequence("", 0, activate, 1);
		case 2:
			AvatarPhoto.setSequence("", 0, activate2, 1);
		case 3:
			AvatarPhoto.setSequence("", 0, sit, 1);
		case 4:
			AvatarPhoto.setSequence("", 0, crouch, 1);
		case 5:
			AvatarPhoto.setSequence("", 0, run, 1);
	}
	
	screenShot($Pref::AvatarPhoto::ScreenshotNumber++ @ ".png", "PNG", 1);
	setRes(getWord(%oldRes, 0), getWord(%oldRes, 1), getWord(%oldRes, 2));
	activateDirectInput();
	cursorOn();
	canvas.popDialog(AvatarPhotoGUI);
	
	clientCmdMessageBoxOK("Photo Saved", "A photo of your avatar has been saved as " @ $Pref::AvatarPhoto::ScreenshotNumber @ ".png in the Blockland folder.");
}